package bmci.esign.backendend.services.impl;

import bmci.esign.backendend.dto.DestinataireDto;
import bmci.esign.backendend.dto.services.IMapClassWithDto;
import bmci.esign.backendend.models.Destinataire;
import bmci.esign.backendend.models.enums.EStatut;
import bmci.esign.backendend.repositories.DestinataireRepository;
import bmci.esign.backendend.services.DestinataireService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class DestinataireServiceImpl implements DestinataireService {

    @Autowired
    private DestinataireRepository destinataireRepository;

    @Autowired
    private IMapClassWithDto<Destinataire, DestinataireDto> destinataireMapping;

    @Override
    public DestinataireDto addDestinataire(DestinataireDto destinataireDto) {
        destinataireDto.setStatut(EStatut.WAITING.name());
        Destinataire destinataire = destinataireMapping.convertToEntity(destinataireDto, Destinataire.class);
        destinataire = destinataireRepository.save(destinataire);
        return destinataireMapping.convertToDto(destinataire, DestinataireDto.class);
    }

    @Override
    public List<DestinataireDto> addAll(List<DestinataireDto> destinataireDtos) {
        List<Destinataire> destinataires = destinataireMapping.convertListToListEntity(destinataireDtos, Destinataire.class);
        destinataires = destinataireRepository.saveAll(destinataires);
        return destinataireMapping.convertListToListDto(destinataires, DestinataireDto.class);
    }


    @Override
    public DestinataireDto updateDestinataire(DestinataireDto destinataireDto, Long id) {
         destinataireRepository.save(destinataireMapping.convertToEntity(destinataireDto, Destinataire.class));
        return destinataireDto;
    }

    @Override
    public DestinataireDto getDestinataire(Long id) {
        return destinataireMapping.convertToDto(destinataireRepository.findById(id).orElse(null), DestinataireDto.class);
    }

    @Override
    public Destinataire findDestinataire(Long id) {
        return destinataireRepository.findById(id).orElse(null);
    }

    @Override
    public List<DestinataireDto> findAllByDemandeId(Long id) {
        return destinataireMapping.convertListToListDto(destinataireRepository.findAllByDemandeId(id), DestinataireDto.class);
    }
}
